GNU bug report logs - #19200
Point adjustemnt moves *into* invisible text

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Stefan Monnier <monnier@HIDDEN>; dated Wed, 26 Nov 2014 22:23:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 22 Mar 2016 18:53:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Mar 22 14:53:41 2016
Received: from localhost ([127.0.0.1]:60378 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1aiRQy-0007Nf-Tn
	for submit <at> debbugs.gnu.org; Tue, 22 Mar 2016 14:53:41 -0400
Received: from eggs.gnu.org ([208.118.235.92]:36316)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1aiRQw-0007NS-S9
 for 19200 <at> debbugs.gnu.org; Tue, 22 Mar 2016 14:53:39 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1aiRQn-0000Rg-Mo
 for 19200 <at> debbugs.gnu.org; Tue, 22 Mar 2016 14:53:33 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.5 required=5.0 tests=BAYES_05,T_RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:32810)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1aiRQc-0000Pn-Sj; Tue, 22 Mar 2016 14:53:18 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:4369
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1aiRQb-0002Sp-0D; Tue, 22 Mar 2016 14:53:17 -0400
Date: Tue, 22 Mar 2016 20:52:57 +0200
Message-Id: <83egb24a5y.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-reply-to: <jwvoaa6pe49.fsf-monnier+Inbox@HIDDEN> (message from Stefan
 Monnier on Tue, 22 Mar 2016 14:36:10 -0400)
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
 <83h9fz65ze.fsf@HIDDEN> <jwv4mbzwrzk.fsf-monnier+bug#19200@HIDDEN>
 <83r3f24gbk.fsf@HIDDEN> <jwvoaa6pe49.fsf-monnier+Inbox@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 19200
Cc: michael_heerdegen@HIDDEN, jonas@HIDDEN, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: 19200 <at> debbugs.gnu.org,  michael_heerdegen@HIDDEN,  jonas@HIDDEN
> Date: Tue, 22 Mar 2016 14:36:10 -0400
> 
> > So what exactly is this bug about?
> 
> There are 2 odd behaviors:
> - point adjustment doesn't bring us to position 3 after C-n

Why is that a problem?  Position 3 is invisible, so we shouldn't
expect to end up with point there.

> - M-: (point) has the side-effect of bringing us to position 3
>   My guess here is that after the M-: command, at the end of
>   command_loop_1, last_point_position refers to a position in another
>   buffer (i.e. in the minibuffer), so it thinks there was a movement and
>   hence re-runs adjust_point_for_property, which this time gets it right.

Maybe.  If this is the bug to solve, I could look into it.  But your
original reports said this is actually the correct position of point,
a claim which I don't understand.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 22 Mar 2016 18:36:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Mar 22 14:36:18 2016
Received: from localhost ([127.0.0.1]:60353 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1aiRAA-0005JM-9x
	for submit <at> debbugs.gnu.org; Tue, 22 Mar 2016 14:36:18 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.181]:38301)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1aiRA9-0005JB-En
 for 19200 <at> debbugs.gnu.org; Tue, 22 Mar 2016 14:36:17 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: A0A+FgA731xV/5a2xEVcgxCEAoVVwwsEAgKBPD0QAQEBAQEBAYEKQQWDXQEBAwFWIwULCzQSFBgNJIg3CM8jAQEBAQYBAQEBHos6hQUHhC0Fsz+BRSOBZoIuIoJ4AQEB
X-IPAS-Result: A0A+FgA731xV/5a2xEVcgxCEAoVVwwsEAgKBPD0QAQEBAQEBAYEKQQWDXQEBAwFWIwULCzQSFBgNJIg3CM8jAQEBAQYBAQEBHos6hQUHhC0Fsz+BRSOBZoIuIoJ4AQEB
X-IronPort-AV: E=Sophos;i="5.13,465,1427774400"; d="scan'208";a="197786286"
Received: from 69-196-182-150.dsl.teksavvy.com (HELO pastel.home)
 ([69.196.182.150])
 by ironport2-out.teksavvy.com with ESMTP; 22 Mar 2016 14:36:10 -0400
Received: by pastel.home (Postfix, from userid 20848)
 id BDA5063F25; Tue, 22 Mar 2016 14:36:10 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
Message-ID: <jwvoaa6pe49.fsf-monnier+Inbox@HIDDEN>
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
 <83h9fz65ze.fsf@HIDDEN> <jwv4mbzwrzk.fsf-monnier+bug#19200@HIDDEN>
 <83r3f24gbk.fsf@HIDDEN>
Date: Tue, 22 Mar 2016 14:36:10 -0400
In-Reply-To: <83r3f24gbk.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 22 Mar
 2016 18:39:59 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 19200
Cc: michael_heerdegen@HIDDEN, jonas@HIDDEN, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

> But I'm sure you know very well that point adjustment code doesn't use
> get-pos-property, it uses get-char-property-and-overlay, and the
> latter says position 5 is visible.  There was an attempt to use
> get-pos-property in that code, but it backfired and was disabled.

No, I didn't remember (and still don't actually, tho I now see the
corresponding comments and #if0 in the code).

But that change only affects the decision of what we consider as the
boundaries of a chunk of invisible text (so it makes no difference in
the present test case where there is no such ambiguity).

Once those boundaries are found, we do use Fget_pos_property to decide
which boundary to go to.

> So what exactly is this bug about?

There are 2 odd behaviors:
- point adjustment doesn't bring us to position 3 after C-n
- M-: (point) has the side-effect of bringing us to position 3
  My guess here is that after the M-: command, at the end of
  command_loop_1, last_point_position refers to a position in another
  buffer (i.e. in the minibuffer), so it thinks there was a movement and
  hence re-runs adjust_point_for_property, which this time gets it right.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 22 Mar 2016 16:40:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Mar 22 12:40:50 2016
Received: from localhost ([127.0.0.1]:60222 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1aiPMQ-0002YW-GX
	for submit <at> debbugs.gnu.org; Tue, 22 Mar 2016 12:40:50 -0400
Received: from eggs.gnu.org ([208.118.235.92]:54399)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1aiPMN-0002YJ-Ul
 for 19200 <at> debbugs.gnu.org; Tue, 22 Mar 2016 12:40:48 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1aiPMD-0007FM-50
 for 19200 <at> debbugs.gnu.org; Tue, 22 Mar 2016 12:40:42 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.0 required=5.0 tests=BAYES_20,T_RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:58881)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1aiPLx-0007AS-Vt; Tue, 22 Mar 2016 12:40:22 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:4175
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1aiPLu-0007rt-J5; Tue, 22 Mar 2016 12:40:21 -0400
Date: Tue, 22 Mar 2016 18:39:59 +0200
Message-Id: <83r3f24gbk.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-reply-to: <jwv4mbzwrzk.fsf-monnier+bug#19200@HIDDEN> (message from Stefan
 Monnier on Mon, 21 Mar 2016 16:43:21 -0400)
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
 <83h9fz65ze.fsf@HIDDEN> <jwv4mbzwrzk.fsf-monnier+bug#19200@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 19200
Cc: michael_heerdegen@HIDDEN, jonas@HIDDEN, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: 19200 <at> debbugs.gnu.org, michael_heerdegen@HIDDEN, jonas@HIDDEN
> Date: Mon, 21 Mar 2016 16:43:21 -0400
> 
> > Can someone tell me why you think point adjustment has anything to do
> > with the original report for this bug?  Because I fail to see any
> > connection; maybe I'm missing something.
> 
> > What I see is that vertical-motion, called by next-line's subroutines,
> > ends up at position 5, because when it tries to get to column zero, it
> > skips the invisible text between positions 3 and 5.  It stops at 5
> > because the function called to move to the goal column can only move
> > within a single display line.  IOW, this is a simple artifact of the
> > implementation of vertical-motion.
> 
> No, it's OK for vertical-motion to move to position 5.

OK, then I won't install that change.

> But adjust_point_for_property should move it back to position
> 3 (because that still ends up being a forward motion, when compared to
> the original point position, and it is in a "less-invisible" spot).

Your original report says:

  3. M-: (point) RET

    This should say 3 (where get-pos-property says it's not invisible)
    but returns 5 (where get-pos-property says it is invisible)!

But I'm sure you know very well that point adjustment code doesn't use
get-pos-property, it uses get-char-property-and-overlay, and the
latter says position 5 is visible.  There was an attempt to use
get-pos-property in that code, but it backfired and was disabled.

So what exactly is this bug about?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 20:43:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 16:43:31 2016
Received: from localhost ([127.0.0.1]:57380 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai6fj-0001xE-NG
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 16:43:31 -0400
Received: from pruche.dit.umontreal.ca ([132.204.246.22]:33661)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1ai6fh-0001x4-Qf
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 16:43:30 -0400
Received: from pastel.home (lechon.iro.umontreal.ca [132.204.27.242])
 by pruche.dit.umontreal.ca (8.14.7/8.14.1) with ESMTP id u2LKhO1u032749;
 Mon, 21 Mar 2016 16:43:24 -0400
Received: by pastel.home (Postfix, from userid 20848)
 id 92F2E60587; Mon, 21 Mar 2016 16:43:21 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
Message-ID: <jwv4mbzwrzk.fsf-monnier+bug#19200@HIDDEN>
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
 <83h9fz65ze.fsf@HIDDEN>
Date: Mon, 21 Mar 2016 16:43:21 -0400
In-Reply-To: <83h9fz65ze.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 21 Mar
 2016 20:28:05 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-NAI-Spam-Flag: NO
X-NAI-Spam-Threshold: 5
X-NAI-Spam-Score: 0
X-NAI-Spam-Rules: 1 Rules triggered
	RV5617=0
X-NAI-Spam-Version: 2.3.0.9418 : core <5617> : inlines <4542> : streams
 <1606668> : uri <2171602>
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: 19200
Cc: michael_heerdegen@HIDDEN, jonas@HIDDEN, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.3 (-)

> Can someone tell me why you think point adjustment has anything to do
> with the original report for this bug?  Because I fail to see any
> connection; maybe I'm missing something.

> What I see is that vertical-motion, called by next-line's subroutines,
> ends up at position 5, because when it tries to get to column zero, it
> skips the invisible text between positions 3 and 5.  It stops at 5
> because the function called to move to the goal column can only move
> within a single display line.  IOW, this is a simple artifact of the
> implementation of vertical-motion.

No, it's OK for vertical-motion to move to position 5.

But adjust_point_for_property should move it back to position
3 (because that still ends up being a forward motion, when compared to
the original point position, and it is in a "less-invisible" spot).

> Michael, does the patch below fix the Magit problem?  (It does fix the
> simple test case presented by Stefan at the beginning of this bug
> report.)

It just works around the problem, AFAICT.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 20:22:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 16:22:09 2016
Received: from localhost ([127.0.0.1]:57359 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai6L3-0001PQ-J3
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 16:22:09 -0400
Received: from mout.web.de ([212.227.15.3]:61389)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1ai6L1-0001PD-Mk
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 16:22:08 -0400
Received: from drachen.dragon ([94.218.210.27]) by smtp.web.de (mrweb004) with
 ESMTPSA (Nemesis) id 0MF7Nb-1aXwvF2LCF-00GGle;
 Mon, 21 Mar 2016 21:21:58 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
 <83h9fz65ze.fsf@HIDDEN> <87vb4f7hxs.fsf@HIDDEN>
 <83a8lr62m2.fsf@HIDDEN> <87r3f37fsz.fsf@HIDDEN>
Date: Mon, 21 Mar 2016 21:21:56 +0100
In-Reply-To: <87r3f37fsz.fsf@HIDDEN> (Michael Heerdegen's message of "Mon, 21
 Mar 2016 21:10:36 +0100")
Message-ID: <87k2kv7fa3.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K0:/sWwQ03XAHAvHGgWi6sIWwwqrnw56bNvG/iTHb9nkmuLiojJT4I
 d/ZV/dkN+G72RuJfIMdX+NldS/u1C4YWh5vwH5u03tCISXYEOnuMiCALuYR7aKhHl0WsfRx
 aAzfkVu4L6KUqJsZGKAVH3tO6CeKcqh8JKWIVNv78Z+v/gTV9bEnRgKWxm6Cyq74i9inkij
 9uLzjwy5v9FaxqXPRo2SA==
X-UI-Out-Filterresults: notjunk:1;V01:K0:YteYCW52olM=:LKECVz3IT/e+VEPIM4KoG7
 uMSIhCbQ2Hub6FSk8l9iKmH+6Synxzdfh02Ut3/VuVN3Ej38ot2IiJ/MWZpkTEV+uIqFgwGkf
 zGD3zrX1sY1hpyr4JuTA+7zhIbn632dlDTPU5JV/3EHmPWwlhDGn4a+q3bn62K1S8VKKSWZth
 ANIvsgdda9ITjnHDi7a2TwozDG7IP6JOLKUGY2mwJ/e5UuIvk8CKHE3eUrdPFyvY2ZDVdMURD
 E0o/H25EOs08ZfsIl+Jq4MBUC86Bc6ToSe5IjFfBgtj8P1CxPB3+wLD7lvZW8k6rwH6Bd5UgM
 pUbBTUHJ5xeIWL2zbAnJLxI1igsbL5khi6D+KQeWvGF3F5Y/yf0bo7T4YKWgarFHIZWs2ob4u
 DIRJMNu3k60qg8Qnk+AzC3UmARRKVJp2Xo/ounnoVtHV8/iuN2cDOvUvN6ZlsrRcSqu7/9nWa
 YVyT+A3ZuoYEr7B7Xbo7es/BQnPlxes5h9cKqR2GqdpTE9VPb5OPK4sAoexVQVswt5CByLvZx
 K7nMSa4GStJUMFv8aKurWdxaxzWGEJIAewtSdNq+AWfiEz4576oPYC+Rbqiys46Ct3FZVYtKN
 I0pXOMFf2jR7MUveTtckEgVnvv/IS2oIJzmMeOS0f8vdTUB24m8mMPYEIDIaJKQDLBtTdXssk
 1N3rXAtw+we1F5UlxY4b7raEo2io/MbTAIcjFwFoVG4GwrjXS9IkKHT0RpW8OxDaOGO4USUwc
 8bbHVQC3F4SIITC5azng/rYMU8dKKz5gIa3hWlmS3LqugCnSdPEQVkJxeq6lNEXFsWG/I9V/5
 +u8N6jI
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19200
Cc: 19200 <at> debbugs.gnu.org, jonas@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> > I think you should file a separate bug for it.
>
> Ok, will do.  Thanks for investing time here.

Done: bug#23079.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 20:10:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 16:10:50 2016
Received: from localhost ([127.0.0.1]:57348 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai6A6-0007vB-9a
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 16:10:50 -0400
Received: from mout.web.de ([212.227.15.14]:52049)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1ai6A5-0007uz-6J
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 16:10:49 -0400
Received: from drachen.dragon ([94.218.210.27]) by smtp.web.de (mrweb004) with
 ESMTPSA (Nemesis) id 0LocJe-1a7Nky28AU-00gUnV;
 Mon, 21 Mar 2016 21:10:38 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
 <83h9fz65ze.fsf@HIDDEN> <87vb4f7hxs.fsf@HIDDEN>
 <83a8lr62m2.fsf@HIDDEN>
Date: Mon, 21 Mar 2016 21:10:36 +0100
In-Reply-To: <83a8lr62m2.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 21 Mar
 2016 21:40:53 +0200")
Message-ID: <87r3f37fsz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K0:NpRHJJ2vzv8pjyUekrxyFQgvp9ZWEE+y5LnTdNcSyTqvYWk8yxC
 Xxt6vuUUFwgzM3I6BbrO8IX2adXtAOk6ywrj4KZAqj1KVfEcGbBIW35F8X0HdvVG+j2yh1g
 DzVHDPJ5EIGsVNauIEz86QUoJBGDxeGvcB/yWZUE2HDeVHerBo7om1dN/xXrSDMG0vZGb4K
 XBbdYbMDV9rMrJ3bsW4mQ==
X-UI-Out-Filterresults: notjunk:1;V01:K0:lNuSfAaxyK0=:CLQ+3OZbZNc/AKhUbX4piW
 sV2cHjozm+8uk8oyokWQcw7+CRs6xUHrZ638EwEf9012/JmqCcco8fUhVL4MhggEfaBCO2b9o
 seiFks/Gyn2mZC8OcuCG69XYt0ejUP+ek6fiN6Q6/PLLGXuf+HcYsbbv3oYsVvkqbaYwqW+lP
 G1PsLijD93jOyBPoJmbek47APzH7xnw/02ragCKx92cLCowzqXmvF8AE2bsv+ctnfDxW998YR
 1xoXopRObV/A7n067UwA3dy0yGwWlfK6Tjbv+zZrjmfcKKXnsQ8pr9q3S77aFkRGvZDpijgF4
 uDvspgI88vnAf1FxqdMEe2huc/0D8pz/DeU4DNiTGxL98z1ZQXwFLLXMR/LVkbXbVTPXw0DXL
 IqjlrYlHn7Iwu+OpxZoBCq7iZbT3Fqg/1YtXeIhyse6M/JaIUw2u1NmDeA5M53cRma8DQhU3W
 Ht3ADoS0Y3zP4xYRf4tXcN+E2/cpmdoOBYne+/vc8dopx3M6eiZ15xiNevwWT+bf4nzEmrI2z
 5Ml6hjEy2CVCgCFovcgF8zdBQCNgZZkQOhlPyIshxNey5OrZG9cAvvjXfr6Aj/R47VsQfAnnn
 CdGk8Cga5zDztQ5xV5//wioOH5FEuHQngL2Y3eIY73St3OKzaaiwKXCZTtKXvqBwN/bgfxXcW
 MCoON4jyfdFhTRSgR9CmuvdQUjkFsZeCZ37eA8pcDFDDSNsM+Qio1EwZI3u1dMRYnLNnbccjx
 E885u2JXGoQCo0Hk9kjx123YZKR67pzJkCL1xgYScBFi+skZU34ql08W1659ChqlKagO9uavI
 t197f7k
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19200
Cc: 19200 <at> debbugs.gnu.org, jonas@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

> > (progn
> >   (insert "111" "\n222\n"
> >           (propertize "333\n444\n\n" 'invisible t)
> >           "555\n666\n"))
>
> This is an entirely different problem.

Hmm, ok.


> Why do you need line-number-mode and goal-column?

`line-number-mode' because I really meant `hl-line-mode': that would
have shown a visible effect, namely that cursor is located on a line
different from the one where it appears.  But yes, it's unrelated to the
recipe.

Second question: for the recipe, it's not relevant indeed, but it is in
Magit, because in Magit, they have set line-move-visual -> nil.  That
fixes the problem, but it fails to do so (only) when goal-column -> nil.

>  I can see the problem just by moving with C-f from the end of the
> "222" line: "C-x =" says point is on the first "3", but the cursor is
> shown on "5".  Isn't this the problem you want fixed?

Yes!

> > I wonder however why in the above recipe the M-: (point) trick does
> > _not_ "work".
>
> Because it's an entirely different problem.

But in Magit, it _does_ help (i.e. move the cursor out of the invisible
text).  In my recipe, which is modeled after the Magit case, it doesn't.

> I think you should file a separate bug for it.

Ok, will do.  Thanks for investing time here.


Regards,

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 19:41:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 15:41:26 2016
Received: from localhost ([127.0.0.1]:57336 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai5he-0007FA-J8
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 15:41:26 -0400
Received: from eggs.gnu.org ([208.118.235.92]:42816)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ai5hd-0007Ev-79
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 15:41:25 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1ai5hU-0002uu-Qo
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 15:41:20 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:35350)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ai5hU-0002uq-NR; Mon, 21 Mar 2016 15:41:16 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:3111
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ai5hT-0002ch-S4; Mon, 21 Mar 2016 15:41:16 -0400
Date: Mon, 21 Mar 2016 21:40:53 +0200
Message-Id: <83a8lr62m2.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
In-reply-to: <87vb4f7hxs.fsf@HIDDEN> (message from Michael Heerdegen on Mon,
 21 Mar 2016 20:24:31 +0100)
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
 <83h9fz65ze.fsf@HIDDEN> <87vb4f7hxs.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 19200
Cc: 19200 <at> debbugs.gnu.org, jonas@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

> From: Michael Heerdegen <michael_heerdegen@HIDDEN>
> Cc: Stefan Monnier <monnier@HIDDEN>,  jonas@HIDDEN,  19200 <at> debbugs.gnu.org
> Date: Mon, 21 Mar 2016 20:24:31 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Michael, does the patch below fix the Magit problem?  (It does fix the
> > simple test case presented by Stefan at the beginning of this bug
> > report.)
> 
> Unfortunately, no.
> 
> Here is a test case which hopefully resembles the situation in Magit:
> 
> (progn
>   (insert "111" "\n222\n"
>           (propertize "333\n444\n\n" 'invisible t)
>           "555\n666\n"))

This is an entirely different problem.

> Turn on line-number-mode and set goal-column -> 0, and move around
> (Esp. up/down).  You'll see the cursor drawn over the first "5", but
> point is actually located inside the invisible text.

Why do you need line-number-mode and goal-column?  I can see the
problem just by moving with C-f from the end of the "222" line:
"C-x =" says point is on the first "3", but the cursor is shown on
"5".  Isn't this the problem you want fixed?

> I wonder however why in the above recipe the M-: (point) trick does
> _not_ "work".

Because it's an entirely different problem.

I think you should file a separate bug for it.

Meanwhile, perhaps Stefan can see if my proposed change fixes whatever
the real-life use case he first saw the problem in, not just the
recipe he posted.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 19:24:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 15:24:44 2016
Received: from localhost ([127.0.0.1]:57316 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai5RU-0005BS-GG
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 15:24:44 -0400
Received: from mout.web.de ([212.227.17.11]:56505)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1ai5RS-0005BE-Ka
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 15:24:43 -0400
Received: from drachen.dragon ([94.218.210.27]) by smtp.web.de (mrweb101) with
 ESMTPSA (Nemesis) id 0M1oGM-1Zu69b2IZO-00tmWh;
 Mon, 21 Mar 2016 20:24:33 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
 <83h9fz65ze.fsf@HIDDEN>
Date: Mon, 21 Mar 2016 20:24:31 +0100
In-Reply-To: <83h9fz65ze.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 21 Mar
 2016 20:28:05 +0200")
Message-ID: <87vb4f7hxs.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K0:vu9sMVqufSoNsANKJfVZrzBGJ412SY+jD5+RJo/eN6Fck28pQnR
 JvquMQ/ofsmaSFspK2+zjAmsZgOnswIkmNBAS3yRogGP9n7sRBKtlga9cI851dyqvawW39t
 c3GKwh9JtfiLwZp4aamOYrADUjBXpAy8q/Ll0qyxETteRjbBIWwa03kxRqxw10HuWZx9AiP
 Jshf4yxe33e8suTVgfteA==
X-UI-Out-Filterresults: notjunk:1;V01:K0:Zlk4Q/uUOBY=:e2qonmj2HHjQM8UX4EDP/v
 KxwnHTSdzOw2V2IIrMKyYj2bjOXYryZcOGikGowYBrE+6gPkvswJiJGI4OadDeLNHEACiQS8c
 jJuwRuBJ3586YErb2QbgmY5CMFBH0miOi0mH00oADI9ZaxEBBjFty4/jI7o/4gKKV8hu5kIIt
 urhbc5D6b17QgveZmcs+vIZ9n3IxdFZsViyLh4mBR03HZdOMzwbZzlqRCBjUBVyj/kjvhSDMC
 nK+C/wepnp1yver0XQ2ZxCu4tmvQL0r6mP1JYWillKh2bOWwChxR2tLhy/u/k8Rt3IExLeR43
 /JRfVqS28cGGTobfZXa7oMBXg3O+o93Z4gSsckwv241ZpHo6ttO9me9rlOhuXSCj5gxrrNhmO
 +76sM7eHBKX7NlG2qh4Tgyx5pVt+NhRIsLqJzVXyIiVyv6BVuYhwWXqEBveNRMHtqBxfdUejI
 wq9cdPhjOPmELulUlEcGdNvDBRSj+HLDFxocMznQChX4v3VVMkP99TMTbHAkHTj3GH4JbkRjg
 nppxqPNwn7WSUeKcTX1TogLshHJjEjVntb6xyMlWAH8xIqfepM0YQURda3xWXZ/z87u45CG3d
 MuggMFYlq1U1AZimGq1YkW3E783EVLeIpxFhVvS+I/sbUH4hFjtABYB1oySg/kPWIO6T/c0Dh
 HiPKZr88TTA8KY+2q2FPwMSAiOMsibl1nL2/y0d56p9tJAToshkqh5NnAFlFgdI/RFq+faWo9
 doFw5STNHU1usbMKj/WyMK91KHQ9mG984G7ILZen+ptx4ZW3X7N1ogLhNqMZzU2nsSIAvhVc5
 uS53Ed3
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19200
Cc: 19200 <at> debbugs.gnu.org, jonas@HIDDEN,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

> Michael, does the patch below fix the Magit problem?  (It does fix the
> simple test case presented by Stefan at the beginning of this bug
> report.)

Unfortunately, no.

Here is a test case which hopefully resembles the situation in Magit:

(progn
  (insert "111" "\n222\n"
          (propertize "333\n444\n\n" 'invisible t)
          "555\n666\n"))

Turn on line-number-mode and set goal-column -> 0, and move around
(Esp. up/down).  You'll see the cursor drawn over the first "5", but
point is actually located inside the invisible text.

I wonder however why in the above recipe the M-: (point) trick does
_not_ "work".


Regards,

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 18:50:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 14:50:41 2016
Received: from localhost ([127.0.0.1]:57283 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai4uX-0004Jl-Kv
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:50:41 -0400
Received: from mout.web.de ([212.227.15.4]:58986)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1ai4uV-0004JY-OG
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:50:40 -0400
Received: from drachen.dragon ([94.218.210.27]) by smtp.web.de (mrweb004) with
 ESMTPSA (Nemesis) id 0MLUDi-1aicsB0Wtm-000ZFf;
 Mon, 21 Mar 2016 19:50:29 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <83egb365u0.fsf@HIDDEN>
Date: Mon, 21 Mar 2016 19:50:26 +0100
In-Reply-To: <83egb365u0.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 21 Mar
 2016 20:31:19 +0200")
Message-ID: <87zitr7jil.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K0:zGz9XdbzcYPboXjg1QM41YsFRlW99brsJ447BBvZ5xy9ZFkxYya
 XTmNC828AbeBV5rnrxQFdmSMo1Qjd24POx0KzcoztIw3Ig7S4Y53Uocxjg0TEgPZ4kZDTpg
 O1KSANq4ns9yybHOrtXkHTHcCOEPzbTiUXvTZy2QoUZwlo3kOtiw4bFzGyx3/UVKZI5OUtv
 /EtWIIjcDvggyENDzIYkw==
X-UI-Out-Filterresults: notjunk:1;V01:K0:e0rq+WZ/WqE=:sQC3eiDbMhY2Jv3EnKCerE
 jP47AK7Fmt4UY97RxhLIiSOaEYo+iDpZ1z/6Am6G/uxGMrPKMhz8vUfZsibX2TdeWKHc52loB
 9jLKWtMJzoW25bhepcNe1pLdWdYsR6LIs0jYXge+SBSt7Pn4L984K4PemJDnkszVBmekcaM8n
 Zgp+NITwXrG6Gk+i7UYioz8Fo8g/RcXVOgmCSwOnJe1DbXJrt9sdhmkcCFuOC5fY/CfqBSYxX
 tFgSQOWRUXAvoOsH6OeNepXgFRwlfg4Htz6DRtylCstl2Y/IuxwmsbtBvCz+gf7D5rcwylW0X
 6X46RYiAzIWoEGx/G/dceQV2h3HwiwKutMTnjcv2MDjoq6j2xyEQpU2/EBdO4MjJxW7zsgx0K
 VxEfCTnGjvaGHVL1Fuyqiab40n5xC8u3TcKLbc2qKpvIrxE4PHnKUC0qjB2wqiC4J82HeET3x
 6n5lDWupc6q0sSsoWyaTbF7+j3PeeNe4JK2NpTfcf7VwQpAoOatpqUcugrDd6f10UaexOV01/
 /HGkBs6K5sDdGqsZQe6uBooMMQH/WcInvbPsO1UWCDWSIGkjWP+UIu9WBdbqWuCsIunP+RAc8
 eJbYuCfP28ej7XIKScycrhXTSfAywUms3S6VfM8yXbekQhWNjq/Cb9HIuN4TdeAaG6Tkqm3Dp
 Msz1e7T5sTokKQHstVPBtZB+LySy60W0o2mi4joWWLAEWqiGFGq3hEqwXVJEK1hamK/ygPHrz
 q4+V6YMgONvWTTG+tLqrcEO0rhviTdE9YDanx6gRhcC1jDQlxBEg02fSr5L9XYf5+BJ0/Ww7o
 k6HZOqU
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19200
Cc: jonas@HIDDEN, 19200 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

> This code is not executed when running Stefan's original test case.

I guess that's the cause why my "fix" doesn't help for his recipe ;-)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 18:31:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 14:31:53 2016
Received: from localhost ([127.0.0.1]:57262 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai4cL-0003s7-CN
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:31:53 -0400
Received: from eggs.gnu.org ([208.118.235.92]:53535)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ai4cK-0003rv-KO
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:31:52 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1ai4cE-0002ID-RW
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:31:47 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:33510)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ai4c9-0002BX-EI; Mon, 21 Mar 2016 14:31:41 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:3038
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ai4c8-0001ak-J6; Mon, 21 Mar 2016 14:31:41 -0400
Date: Mon, 21 Mar 2016 20:31:19 +0200
Message-Id: <83egb365u0.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
In-reply-to: <87io0gbmpl.fsf@HIDDEN> (message from Michael Heerdegen on Mon,
 21 Mar 2016 03:15:34 +0100)
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN> <87mvpskb84.fsf@HIDDEN>
 <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN> <87io0gbmpl.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 19200
Cc: jonas@HIDDEN, 19200 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

> From: Michael Heerdegen <michael_heerdegen@HIDDEN>
> Date: Mon, 21 Mar 2016 03:15:34 +0100
> Cc: 19200 <at> debbugs.gnu.org, Jonas Bernoulli <jonas@HIDDEN>
> 
> And I found that when I replace
> 
>   (if (zerop col)
>       (beginning-of-line)
>     (move-to-column col))
> 
> in the definition of line-move-to-column (at the beginning) with just
> 
>   (move-to-column col)
> 
> (i.e. the else case)
> 
> the Magit issue is fixed.  I have no clue why, however.

This code is not executed when running Stefan's original test case.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 18:31:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 14:31:03 2016
Received: from localhost ([127.0.0.1]:57259 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai4bX-0003r4-3H
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:31:03 -0400
Received: from eggs.gnu.org ([208.118.235.92]:53430)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ai4bV-0003qb-B1
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:31:01 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1ai4bP-0001sk-FV
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:30:56 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:33501)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ai4bI-0001rV-9O; Mon, 21 Mar 2016 14:30:48 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:3037
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ai4bH-0000Sh-El; Mon, 21 Mar 2016 14:30:47 -0400
Date: Mon, 21 Mar 2016 20:30:26 +0200
Message-Id: <83fuvj65vh.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
In-reply-to: <87egb4bmbo.fsf@HIDDEN> (message from Michael Heerdegen on Mon,
 21 Mar 2016 03:23:55 +0100)
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <87egb4bmbo.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 19200
Cc: jonas@HIDDEN, 19200 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

> From: Michael Heerdegen <michael_heerdegen@HIDDEN>
> Date: Mon, 21 Mar 2016 03:23:55 +0100
> Cc: 19200 <at> debbugs.gnu.org, Jonas Bernoulli <jonas@HIDDEN>
> 
> And Edebug at least reveals that it is the cursor adjustment that moves
> point into invisible text

If Edebug told you that, then Edebug lied.  It's vertical-motion, not
point adjustment.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 18:28:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 14:28:45 2016
Received: from localhost ([127.0.0.1]:57254 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai4ZJ-0003le-H0
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:28:45 -0400
Received: from eggs.gnu.org ([208.118.235.92]:52861)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ai4ZH-0003lR-Sp
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:28:44 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1ai4ZB-0001RN-Oq
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:28:38 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:33456)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ai4Z2-0001QD-O6; Mon, 21 Mar 2016 14:28:28 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:3036
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ai4Z1-0005b4-TE; Mon, 21 Mar 2016 14:28:28 -0400
Date: Mon, 21 Mar 2016 20:28:05 +0200
Message-Id: <83h9fz65ze.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-reply-to: <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN> (message from Stefan
 Monnier on Mon, 21 Mar 2016 11:36:23 -0400)
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 19200
Cc: michael_heerdegen@HIDDEN, jonas@HIDDEN, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

> From: Stefan Monnier <monnier@HIDDEN>
> Date: Mon, 21 Mar 2016 11:36:23 -0400
> Cc: 19200 <at> debbugs.gnu.org, Jonas Bernoulli <jonas@HIDDEN>
> 
> >> The way point-adjustment is defined is too conservative for that.
> >> So I suggest you try and make you code more robust w.r.t the position of
> >> point within an invisible region in any case.
> > Well, we just want that cursor movement starting from a visible position
> > not end up at an invisible position - the docs seem to suggest that this
> > should not happen, right?
> 
> It doesn't guarantee it in all cases, no.  E.g. it won't work if the
> command that moves point started/ended in another buffer, or if the
> command set disable-point-adjustment, plus a few other cases.
> 
> > We have the following, very simple situation:
> 
> > Line N
> > { M invisible lines here }
> > Line N+M+1
> 
> > Line N and Line N+M+1 are completely visible, and displayed after each
> > other.  Point is at the start of Line N, no invisible text near that
> > position.  Now I hit [down] one time and end up somewhere inside the
> > invisible text in between.
> 
> I agree it's a bug.  I'm just pointing out that even if we fix this bug,
> there will be other cases which ae not considered bugs where point will
> end up in the middle of the invisible text, and where it would be odd
> for your code to then operate on the selection at the "current line"
> since that's not the line that the user is actually seeing.
> 
> So, yes, point-adjustment needs to be fixed (this is bug#19200), but
> Magit also needs to be fixed anyway (and after that fix, it won't care
> about bug#19200 nearly as much, I think).

Can someone tell me why you think point adjustment has anything to do
with the original report for this bug?  Because I fail to see any
connection; maybe I'm missing something.

What I see is that vertical-motion, called by next-line's subroutines,
ends up at position 5, because when it tries to get to column zero, it
skips the invisible text between positions 3 and 5.  It stops at 5
because the function called to move to the goal column can only move
within a single display line.  IOW, this is a simple artifact of the
implementation of vertical-motion.

Michael, does the patch below fix the Magit problem?  (It does fix the
simple test case presented by Stefan at the beginning of this bug
report.)

diff --git a/src/indent.c b/src/indent.c
index d5162e3..e10b084 100644
--- a/src/indent.c
+++ b/src/indent.c
@@ -2222,7 +2222,8 @@ whether or not it is currently displayed in some window.  */)
 	 an addition to the hscroll amount.  */
       if (lcols_given)
 	{
-	  move_it_in_display_line (&it, ZV, first_x + to_x, MOVE_TO_X);
+	  if (it.current_x < first_x + to_x)
+	    move_it_in_display_line (&it, ZV, first_x + to_x, MOVE_TO_X);
 	  /* If we find ourselves in the middle of an overlay string
 	     which includes a newline after current string position,
 	     we need to move by lines until we get out of the string,




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 18:08:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 14:08:58 2016
Received: from localhost ([127.0.0.1]:57237 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai4GA-0003I8-2J
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:08:58 -0400
Received: from pruche.dit.umontreal.ca ([132.204.246.22]:54918)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1ai4G7-0003Hz-K2
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 14:08:56 -0400
Received: from pastel.home (lechon.iro.umontreal.ca [132.204.27.242])
 by pruche.dit.umontreal.ca (8.14.7/8.14.1) with ESMTP id u2LI8owU004224;
 Mon, 21 Mar 2016 14:08:50 -0400
Received: by pastel.home (Postfix, from userid 20848)
 id 04E8460587; Mon, 21 Mar 2016 14:08:49 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
Message-ID: <jwvegb3yail.fsf-monnier+Inbox@HIDDEN>
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
 <874mbzesi8.fsf@HIDDEN>
Date: Mon, 21 Mar 2016 14:08:49 -0400
In-Reply-To: <874mbzesi8.fsf@HIDDEN> (Michael Heerdegen's message of "Mon, 21
 Mar 2016 16:54:23 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-NAI-Spam-Flag: NO
X-NAI-Spam-Threshold: 5
X-NAI-Spam-Score: 0
X-NAI-Spam-Rules: 1 Rules triggered
	RV5617=0
X-NAI-Spam-Version: 2.3.0.9418 : core <5617> : inlines <4541> : streams
 <1606611> : uri <2171499>
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: 19200
Cc: Jonas Bernoulli <jonas@HIDDEN>, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.3 (-)

> What would you suggest?

1- Don't use invisible text, remove the text instead.
2- Start any command where it can matter with a call to a function that
   skips forward over invisible text.
3- Make your invisible text intangible (ideally with cursor-intangible,
   since the `intangible' text property has all kinds of nasty side
   effects), so the cursor can't stay inside.
4- Some other solution of your choosing.

> What would a different case that is not a bug in Emacs look like?

Hmm... I did give you examples:

    if the command that moves point started/ended in another buffer, or
    if the command set disable-point-adjustment, plus a few other cases.

> Just adding something that tries to repair what goes wrong is not
> enough.

Why not?

> If cursor movement can end up at a random position inside invisible
> text, we would need to reimplement all moving commands, since we
> cannot derive from the cursor position what the correct position would
> have been.  With other words, I don't see what part of this issue is
> specific to Magit.

Magit is the one which introduces invisible text.
The core functions can't know exactly why the text is invisible and
hence what to do about it in each and every possible case.  Only Magit
knows that.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 15:54:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 11:54:37 2016
Received: from localhost ([127.0.0.1]:57127 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai2A9-0008RG-Fh
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 11:54:37 -0400
Received: from mout.web.de ([212.227.17.12]:57449)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1ai2A7-0008R3-Qz
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 11:54:36 -0400
Received: from drachen.dragon ([94.218.210.27]) by smtp.web.de (mrweb102) with
 ESMTPSA (Nemesis) id 0MC1jI-1aZGiX3iAS-008qXs;
 Mon, 21 Mar 2016 16:54:26 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN> <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
Date: Mon, 21 Mar 2016 16:54:23 +0100
In-Reply-To: <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN> (Stefan Monnier's message
 of "Mon, 21 Mar 2016 11:36:23 -0400")
Message-ID: <874mbzesi8.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K0:zR+bKUJU61to01qeRS1woA7ECamfj3xAphcjT92/AMzwnw5eOVk
 q8my2eeXTgRXd0pSDvNc7wT9aTIkEAhYr2f2ItLlY8JXNrAY3d1sw7bykqITvbjN3cDUxBv
 EH5x7MWeM+nWPq44QH75ECHPpg2Yw55koPxU6yZ20Vw7H6QvE0DlocDo6sNP4pP15QaJCwA
 UzAG3s39ZjXGh+fX2Ki1Q==
X-UI-Out-Filterresults: notjunk:1;V01:K0:ukgF8q6yD0A=:C0G0TF50xX643OhmOumPNl
 ym1XdDCNv33V494GbSXBJoZ+x5LhNM9GfchRxMnVFFAfENv25HwDPms/P8pqWJ9MFVbEBj1qD
 43GLMSv3MsKH2l5Ass7hgJSBgYNZIVlNg5NJpauEfTDQxa8HIPcV9mJCjmHQ7HgVdl/MErO49
 FVINWhgM1eUXJYEgEG7SOI6Q/FwxJ0quJt3BjciALbpHIu2p9XxkNnDLJTZrt0UPoEuXfBwnd
 URxN3rVvO09+LDoHtNEfkXg8KixqDRMdKLOZVOlEFx+m3NwJWy97DfgO3Np4z9TN9UtWgIrfA
 SCa4i5nycsB8xiRvaQ+uTjj/8IBwF2X/NEs3r1ZTyuXEaaLRw8gyfljqnIcM9LTBIZR5rg6yo
 +VaAZQ/5EuaaT5XT2TMMAezhQmvgGJt7Pnca/ZHRdLwhCbKDI0rZ4rKfFPXpI5SaJYmFJKnJ8
 ygACmFQ0JmcflvcL0g9m6LKrDnuyPt5yIj0WyaD1uzPqhvW4saDG5Jkq0Zm6uoxsdePeUJyxl
 VlhGrETh+7LAh+tRG4ZYnLmtW3e4LkuXpgTtVCCOVepbx26QtF08rxVcAD4mbnqxsKq6z15Cs
 nJrXJ2eMoEgibwMWa4PGQibaWlSABSq7qObUKUnh5LnInjBoIhdVg+U8gEUCr8hSvD3XcKg22
 wb9FfbjzXyAYN0lz0Pfw2+ZHib4pSSOqQ+A4bSCLHEpTRyiv8NMJfEtNel8cAsif4D5ieGpms
 fYDMN5yNsWMwx32DIzEZlinNXAIdLFrPpDdBaz2FeEVtkq8hgoUfnumiPk/KGofg6CxzM/BMA
 Sp2Hv9c
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19200
Cc: Jonas Bernoulli <jonas@HIDDEN>, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Stefan Monnier <monnier@HIDDEN> writes:

> So, yes, point-adjustment needs to be fixed (this is bug#19200), but
> Magit also needs to be fixed anyway (and after that fix, it won't care
> about bug#19200 nearly as much, I think).

What would you suggest?  What would a different case that is not a bug
in Emacs look like?

Just adding something that tries to repair what goes wrong is not
enough.  If cursor movement can end up at a random position inside
invisible text, we would need to reimplement all moving commands, since
we cannot derive from the cursor position what the correct position
would have been.  With other words, I don't see what part of this issue
is specific to Magit.


Michael.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 15:36:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 11:36:31 2016
Received: from localhost ([127.0.0.1]:57098 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai1sd-00081D-G7
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 11:36:31 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.181]:12303)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1ai1sc-000810-1E
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 11:36:30 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: A0AxFgA731xV/7yMCkxcgxCEAoVVu0CHSwQCAoE8OhMBAQEBAQEBgQpBBYNdAQEDAVYjBQsLNBIUGA0kiDcIzyMBAQEBBgEBAQEeizqFBQeELQWfF5IUghSBRSOBZoIuIoJ4AQEB
X-IPAS-Result: A0AxFgA731xV/7yMCkxcgxCEAoVVu0CHSwQCAoE8OhMBAQEBAQEBgQpBBYNdAQEDAVYjBQsLNBIUGA0kiDcIzyMBAQEBBgEBAQEeizqFBQeELQWfF5IUghSBRSOBZoIuIoJ4AQEB
X-IronPort-AV: E=Sophos;i="5.13,465,1427774400"; d="scan'208";a="197439930"
Received: from 76-10-140-188.dsl.teksavvy.com (HELO pastel.home)
 ([76.10.140.188])
 by ironport2-out.teksavvy.com with ESMTP; 21 Mar 2016 11:36:23 -0400
Received: by pastel.home (Postfix, from userid 20848)
 id 4805E605A0; Mon, 21 Mar 2016 11:36:23 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
Message-ID: <jwvmvprvocz.fsf-monnier+Inbox@HIDDEN>
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
 <87d1qnevco.fsf@HIDDEN>
Date: Mon, 21 Mar 2016 11:36:23 -0400
In-Reply-To: <87d1qnevco.fsf@HIDDEN> (Michael Heerdegen's message of "Mon, 21
 Mar 2016 15:52:55 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 19200
Cc: Jonas Bernoulli <jonas@HIDDEN>, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

>> The way point-adjustment is defined is too conservative for that.
>> So I suggest you try and make you code more robust w.r.t the position of
>> point within an invisible region in any case.
> Well, we just want that cursor movement starting from a visible position
> not end up at an invisible position - the docs seem to suggest that this
> should not happen, right?

It doesn't guarantee it in all cases, no.  E.g. it won't work if the
command that moves point started/ended in another buffer, or if the
command set disable-point-adjustment, plus a few other cases.

> We have the following, very simple situation:

> Line N
> { M invisible lines here }
> Line N+M+1

> Line N and Line N+M+1 are completely visible, and displayed after each
> other.  Point is at the start of Line N, no invisible text near that
> position.  Now I hit [down] one time and end up somewhere inside the
> invisible text in between.

I agree it's a bug.  I'm just pointing out that even if we fix this bug,
there will be other cases which ae not considered bugs where point will
end up in the middle of the invisible text, and where it would be odd
for your code to then operate on the selection at the "current line"
since that's not the line that the user is actually seeing.

So, yes, point-adjustment needs to be fixed (this is bug#19200), but
Magit also needs to be fixed anyway (and after that fix, it won't care
about bug#19200 nearly as much, I think).


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 14:53:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 10:53:09 2016
Received: from localhost ([127.0.0.1]:57062 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ai1Cf-00070d-7Q
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 10:53:09 -0400
Received: from mout.web.de ([212.227.17.12]:57405)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1ai1Cc-00070A-VZ
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 10:53:08 -0400
Received: from drachen.dragon ([94.218.210.27]) by smtp.web.de (mrweb103) with
 ESMTPSA (Nemesis) id 0LpO4v-1a5xIS2ExZ-00f7HL;
 Mon, 21 Mar 2016 15:52:57 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN> <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
Date: Mon, 21 Mar 2016 15:52:55 +0100
In-Reply-To: <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN> (Stefan Monnier's message
 of "Mon, 21 Mar 2016 08:08:59 -0400")
Message-ID: <87d1qnevco.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K0:oYEO3J0iwjlTf9Ty3tDKnxmsUnjZTRhFEuGVzJBoRY/WVHWvEKl
 6ZzZrNlvjpnwkDXDRxsH+GEnGgK6pTlgvgANbeRx+nY1Oup+FNQ8j6ZZM8fWcEFqAS3UrE4
 40ne8dLkHMLN3IX7ZBoEpRwQLhe2SdcCvJQLgdxNUKmnHRw7yerihUgBWusRLhq5WMXxfg2
 PIKkO1oUP9zO/hyICdE1w==
X-UI-Out-Filterresults: notjunk:1;V01:K0:4nlVXP4z4Xg=:pxjz/6PykSyfhXDrw7jGw4
 12ZrXYdWY1jH3IrhtU3xXqQbV0IyleWXbLgxkBCisUnDC8ms8Xs20lsR3f4bJRXM5pp3WJL9f
 7x7hROrxYUbGNp8Pc6kEsM/2CFiA7W6xfjFVncxYGJ93BKB4vqWGSdjcw43blwscan3yg5Vtx
 u7EoQ6hWT+bqWPCfKiL0mc9/CWqPzVeh2ZLhFdIDq6ZK3S3J+QwjNKt2j3veq3BjTn8KvpzP9
 J6FN78yc+Q+Il7S6jt8RYvkgDXGNIo1YUIVZvOEuA6Wx3jNrUoAr/xqV8+SuM1mURILGQAFsi
 EF1L8U4CGqoTImDK2gH10Hk/+1R7Wch+ALCTnWA03t26R5D1nAH6VPMghmIkNVnX0hTSIYg8E
 5mgFs4Fft+mqeJPguIUm7O6S+PmZBD8DGUAiO7fLrDHlZ8xvBo7PBGo12TPzT/SweTh8d9o4y
 LnLOMbkQKtKHqNz4vIpLztIJiWiGdwKHDKCyqrIV1WfFbAUYzpS3HAQUMKiJM5a5rBFsQb9zw
 GiOaDtyWaLHbLztDv7KqARQPC9KV/WdO1c6SH7KWTr3uMpZ/kGANRAwotp32POC2QOvlQJUQV
 ImtOuarLT1Q5lpFWYjykWPz6mlJD6QWVdJ88DxX4DwYBuCQBLYO1vHZRMXFjy9zQoLQJEv6AR
 z83GbyC/O6yHdXV8a3aZuKSgfTFPvzBYE0BDvBW8fqUQwEMeEVr8iU/g9lMspYXVJ3aZydhii
 lTRb1OPSJdTHK6OXkRBpvjoPd5nXoFDlceqV2l5uTNoU8BGvnzX8PL9m4lCzDeSVyHX7WKI/Q
 QPqy6PL
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19200
Cc: Jonas Bernoulli <jonas@HIDDEN>, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Stefan Monnier <monnier@HIDDEN> writes:

> move-to-column moves forward from BOL, whereas beginning-of-line moves
> only backward, so the two probably end up at opposite ends of the
> invisible region.
>
> BTW, regardless of fixing this bug, I think you have a problem: if the
> exact position within the invisible text is so important that it can
> end up
> selecting a different line, then fixing bug#19200 won't do you much
> good: there are many cases where point-adjustment won't do what you want
> (e.g. it won't move point at all, even though it's somewhere in the
> middle of the invisible region) and hence it will end up "at the wrong
> place".
>
> The way point-adjustment is defined is too conservative for that.
> So I suggest you try and make you code more robust w.r.t the position of
> point within an invisible region in any case.

Well, we just want that cursor movement starting from a visible position
not end up at an invisible position - the docs seem to suggest that this
should not happen, right?

We have the following, very simple situation:

Line N
{ M invisible lines here }
Line N+M+1

Line N and Line N+M+1 are completely visible, and displayed after each
other.  Point is at the start of Line N, no invisible text near that
position.  Now I hit [down] one time and end up somewhere inside the
invisible text in between.


Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 12:09:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 21 08:09:08 2016
Received: from localhost ([127.0.0.1]:56320 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ahydv-0002iW-Rq
	for submit <at> debbugs.gnu.org; Mon, 21 Mar 2016 08:09:08 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.181]:64544)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1ahydt-0002i1-Nk
 for 19200 <at> debbugs.gnu.org; Mon, 21 Mar 2016 08:09:06 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: A0AyFgA731xV/3D5d0tcgxCEAoVVu0CHSwQCAoE8OhMBAQEBAQEBgQpBBYNdAQEDAScvIwULCzQSFBgNJIg3CM8jAQEBAQYBAQEBHos6hQUHhC0Fsz+BRSOBZoIuIoJ4AQEB
X-IPAS-Result: A0AyFgA731xV/3D5d0tcgxCEAoVVu0CHSwQCAoE8OhMBAQEBAQEBgQpBBYNdAQEDAScvIwULCzQSFBgNJIg3CM8jAQEBAQYBAQEBHos6hQUHhC0Fsz+BRSOBZoIuIoJ4AQEB
X-IronPort-AV: E=Sophos;i="5.13,465,1427774400"; d="scan'208";a="197391328"
Received: from 75-119-249-112.dsl.teksavvy.com (HELO pastel.home)
 ([75.119.249.112])
 by ironport2-out.teksavvy.com with ESMTP; 21 Mar 2016 08:08:59 -0400
Received: by pastel.home (Postfix, from userid 20848)
 id 06D9B5FED1; Mon, 21 Mar 2016 08:09:00 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
Message-ID: <jwvio0gyrg1.fsf-monnier+Inbox@HIDDEN>
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN>
Date: Mon, 21 Mar 2016 08:08:59 -0400
In-Reply-To: <87io0gbmpl.fsf@HIDDEN> (Michael Heerdegen's message of "Mon, 21
 Mar 2016 03:15:34 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 19200
Cc: Jonas Bernoulli <jonas@HIDDEN>, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

>> Are you sure you're hitting exactly this same bug?
>> IOW can you circumvent the bug by adding M-: (point) RET ?
> First question: no, I'm not, it's similar, but maybe not exactly the
> same.  But second question: yes!

OK, if M-: (point) RET "fixes" the problem, then it's probably hitting
the same bug.

> The issue in Magit seems to be dependent to the setting
> goal-column -> 0.

I don't think that's very surprising: if goal-column is non-zero, then
point doesn't end in an invisible region since you only have invisible text
in column 0, IIUC.

> And I found that when I replace

>   (if (zerop col)
>       (beginning-of-line)
>     (move-to-column col))
>
> in the definition of line-move-to-column (at the beginning) with just
>
>   (move-to-column col)
>
> the Magit issue is fixed.  I have no clue why, however.

move-to-column moves forward from BOL, whereas beginning-of-line moves
only backward, so the two probably end up at opposite ends of the
invisible region.

BTW, regardless of fixing this bug, I think you have a problem: if the
exact position within the invisible text is so important that it can end up
selecting a different line, then fixing bug#19200 won't do you much
good: there are many cases where point-adjustment won't do what you want
(e.g. it won't move point at all, even though it's somewhere in the
middle of the invisible region) and hence it will end up "at the wrong place".

The way point-adjustment is defined is too conservative for that.
So I suggest you try and make you code more robust w.r.t the position of
point within an invisible region in any case.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 02:24:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 20 22:24:08 2016
Received: from localhost ([127.0.0.1]:56074 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ahpVn-0000Hv-VZ
	for submit <at> debbugs.gnu.org; Sun, 20 Mar 2016 22:24:08 -0400
Received: from mout.web.de ([212.227.15.4]:62121)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1ahpVm-0000HO-3A
 for 19200 <at> debbugs.gnu.org; Sun, 20 Mar 2016 22:24:06 -0400
Received: from drachen.dragon ([94.218.210.27]) by smtp.web.de (mrweb002) with
 ESMTPSA (Nemesis) id 0LmcN9-1a7wSd3ivT-00aBWl;
 Mon, 21 Mar 2016 03:23:57 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
 <87io0gbmpl.fsf@HIDDEN>
Date: Mon, 21 Mar 2016 03:23:55 +0100
In-Reply-To: <87io0gbmpl.fsf@HIDDEN> (Michael Heerdegen's message of "Mon, 21
 Mar 2016 03:15:34 +0100")
Message-ID: <87egb4bmbo.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K0:RgzZ4rB/GM+5a6ZgNqMYFKzIy8gDG303oXRadkJsSPhejD9deg7
 utB/eI7TMcGF7OMUmQV9E5YwB4gnmQZZiY7ldjQXZOEfPobk/d8TSp5lPRXz0Qj+gkL9hej
 Qly6lV2Zga2v7A7/bCO9a6x/GSjAg/Z8Redz2ZNlztL/S1AxJiTHWyU6aDwilClXxAF3220
 4tMIR57s2HTOCBm3eD5MQ==
X-UI-Out-Filterresults: notjunk:1;V01:K0:pBZakMCLI5I=:Mk/RcAl0h9nHbURHPAlPZA
 s8/U6kG0OxAL+w7mSGnTLIqhBwdR5IhtyF7NOLjZEAHfL9gnQ6JJgshnjMj7UJjRa3hT+QlLx
 o4k6yOr/ol84ki2Qm0w/368MuBKCsy1EdtgRC48MHvGCFGOdgJ06O6q30Y5j1rmlweFlq4c+e
 gt1DWYYJnUCihCXeMeOTJZ11ZMPRar5/cQwgHXTV+CeZbIh7czTI3mGEIe6m80pq1VpV5aTbX
 QmS6QR6TEy80tdo/v9WaBqzDCR21F/71Un3xOPYt8r65bImtD9GricA1OOAM7fQs/2HeTFgv9
 pkZFlLsJB5BrxXgCpvcDEtNy884Vm6vwY3Z8zWAweCWHe7P92M/xVm+Sqd6YerNaAH4HJGaSL
 zPozr1dMbapY7CAJJkznUaAHLE316fa5IbHGzMV2h3qRJY2xuyZ0YCr39XS1J3H9/jLtEKknG
 9B9M0PGskrpFVGVuzZMMHOZ2v+FZnoAZocvqU/ece0OmC1PUj3QQzarEnxMnB9NvCDjhHgiPa
 AhyXIQH5IyYYi53QRgUAY0xl/JfeDF9IzE2qIV2S1boxENahdh8BZ+J0qZfq9DBaPDpqhJm3K
 RHd1XTQZ1b3f0chtHfSU6uAiNooioMUo3Y33MvIw3n2DikUH2Ndr2+gQEO/Cbl2cUq143TKJy
 7Gqur+8rgq1nnOEs4kG/a398T6Q71bKSSauTg2+m8TMvqJc9rpJ1ogB73IC4lVrhbUkB0pE6W
 fsOvmDX8nUX0BRKfUUi5cSlfgF1+FnCq1aSm9HgsdCuiKFHcLQqxSsEklZyADranly8BwXOJw
 HxhtOyN
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19200
Cc: Jonas Bernoulli <jonas@HIDDEN>, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Stefan Monnier <monnier@HIDDEN> writes:
>
> > > this bug is tantalizing us in Magit:
> > >   https://github.com/magit/magit/issues/2592.
> > > If someone would want to have a look some time...that would be nice!
> >
> > Are you sure you're hitting exactly this same bug?
> > IOW can you circumvent the bug by adding M-: (point) RET ?
>
> First question: no, I'm not, it's similar, but maybe not exactly the
> same.  The issue in Magit seems to be dependent to the setting
> goal-column -> 0.  But second question: yes!

And Edebug at least reveals that it is the cursor adjustment that moves
point into invisible text, so the bug subject is correct for the Magit
issue.

I can post a recipe for this specific case tomorrow.


Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 02:15:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 20 22:15:47 2016
Received: from localhost ([127.0.0.1]:56061 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ahpNj-0008WC-Ni
	for submit <at> debbugs.gnu.org; Sun, 20 Mar 2016 22:15:47 -0400
Received: from mout.web.de ([212.227.17.12]:58072)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1ahpNh-0008Vy-Nw
 for 19200 <at> debbugs.gnu.org; Sun, 20 Mar 2016 22:15:46 -0400
Received: from drachen.dragon ([94.218.210.27]) by smtp.web.de (mrweb101) with
 ESMTPSA (Nemesis) id 0LuM1L-1ZgPpn2mDH-011mkA;
 Mon, 21 Mar 2016 03:15:36 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
 <87mvpskb84.fsf@HIDDEN> <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
Date: Mon, 21 Mar 2016 03:15:34 +0100
In-Reply-To: <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN> (Stefan Monnier's
 message of "Sun, 20 Mar 2016 21:21:53 -0400")
Message-ID: <87io0gbmpl.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K0:XTtPyAQc2lqlmgikd+UbdFp/FKTNusdxn4gq7u92N2hBuXhNUs0
 xOsWyR+xhL1lDYsOafRM5GrzRKvoluPmfrivvvGNb4sMeGv4SyAKYW0aNt4G24nKf10CK4c
 gQXf1hDM99UhnwaitEM/mtcPmSkLHSt1LzSPcHytSib25uf9SHL7m+QEd7SbumZ8HTDBMGX
 7fqQzghLI7C2fOqCw7x8A==
X-UI-Out-Filterresults: notjunk:1;V01:K0:XsRoaf+7jzQ=:nyCz8ACA3JM0dPHt2/xw93
 VSlxoU6F/2iw/GMyM2bzIo2YC/Chta6yTaMHqxRCenPwmFOw6D9bH/YrL82XM5294gTH5Igs5
 G6FfTJEL0Vdc83hczA293YAWQiKpg12WGb44IOoU8GEe+jq2PscGo++TvadsC7g/TbMxuEL+5
 sC2PTFeCf1yei3nkX0X3CHpkTb8iqbUcigwDVhfVnc5XCD9MS2kXAGAcnnA4jwP1mQtQQUy1k
 TQzmH4xA6vlI4NafdQGlJkOrNo9farltgvVaRofpbVmgDgQ5YMhHHZc1xqbw3ik0LbpLpnSWT
 wLcxx0rsQ3GPSAl/W+r7fEPmFb6j+TmdDWVIpe4PxhRLJjY/sHGBx2FE/BLA2DSMQ4AKORNqE
 Fpf2rz66aSp379idasROuCdn+APr4+QnBfDKMKw5xPnbVPdU075ytdvnqDWawWg9KWUthuXsa
 uOgWTKwq7jEeZCmzDtXyV7XkwikxNW9wohxjsUE1yg179ru0G+VLkgfxTttd0QHWTtjmJbQJu
 whERDTeJKjqGlrb4UDAxFeTYnULIvDc8dpua8vhnXwbS+W9QAcW9CnbpfQmoio2WcJovWiKOh
 YElUBYB2KDjg4K03QD6HG7ii9p1bJrjodGZZnxbZ1IEg6opLZsQ2e5tJnvWbqqggnGeWzAUmH
 qEBYdUtv4OTQe4Euu+Tal6i4IvYxF8zOopWTxJshYUKIrtAgw6EGlCo3xtv+nMJP9Qqkdllpg
 NwaDtm26gb1BP2zGaPHAo/EOkELRGpImBZFOTUib1hCLr476dTAbIxxWibZUr3IxzQNiDn2oN
 eAG9t4q
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19200
Cc: Jonas Bernoulli <jonas@HIDDEN>, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Stefan Monnier <monnier@HIDDEN> writes:

> > this bug is tantalizing us in Magit:
> >   https://github.com/magit/magit/issues/2592.
> > If someone would want to have a look some time...that would be nice!
>
> Are you sure you're hitting exactly this same bug?
> IOW can you circumvent the bug by adding M-: (point) RET ?

First question: no, I'm not, it's similar, but maybe not exactly the
same.  The issue in Magit seems to be dependent to the setting
goal-column -> 0.  But second question: yes!


And I found that when I replace

  (if (zerop col)
      (beginning-of-line)
    (move-to-column col))

in the definition of line-move-to-column (at the beginning) with just

  (move-to-column col)

(i.e. the else case)

the Magit issue is fixed.  I have no clue why, however.


Shall I make a separate report - or will cursor-sensor.el care about
this stuff at some time in the future?  Looking at the code in
simple.el, fixing this stuff will not be fun...


Regards,

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 21 Mar 2016 01:22:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 20 21:22:00 2016
Received: from localhost ([127.0.0.1]:56044 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ahoXg-0007Gg-Hq
	for submit <at> debbugs.gnu.org; Sun, 20 Mar 2016 21:22:00 -0400
Received: from pruche.dit.umontreal.ca ([132.204.246.22]:42482)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1ahoXf-0007GY-7X
 for 19200 <at> debbugs.gnu.org; Sun, 20 Mar 2016 21:21:59 -0400
Received: from fmsmemgm.homelinux.net (lechon.iro.umontreal.ca
 [132.204.27.242])
 by pruche.dit.umontreal.ca (8.14.7/8.14.1) with ESMTP id u2L1LrXL015801;
 Sun, 20 Mar 2016 21:21:54 -0400
Received: by fmsmemgm.homelinux.net (Postfix, from userid 20848)
 id A23ECAE240; Sun, 20 Mar 2016 21:21:53 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
Message-ID: <jwvy49cwruw.fsf-monnier+bug#19200@HIDDEN>
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN> <87mvpskb84.fsf@HIDDEN>
Date: Sun, 20 Mar 2016 21:21:53 -0400
In-Reply-To: <87mvpskb84.fsf@HIDDEN> (Michael Heerdegen's message of "Sun, 20
 Mar 2016 23:58:51 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-NAI-Spam-Flag: NO
X-NAI-Spam-Level: *
X-NAI-Spam-Threshold: 5
X-NAI-Spam-Score: 1.1
X-NAI-Spam-Rules: 5 Rules triggered
 SORT_LNK_1HTP_CTPLN_W_GEN_SPAM_FEATRE=0.5, GEN_SPAM_FEATRE=0.2, 
 SORT_LNK_1HTP_CTPLN=0.2, TRK_NCM1=0.2, RV5616=0
X-NAI-Spam-Version: 2.3.0.9418 : core <5616> : inlines <4536> : streams
 <1606241> : uri <2170935>
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: 19200
Cc: Jonas Bernoulli <jonas@HIDDEN>, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.3 (-)

> this bug is tantalizing us in Magit:
>   https://github.com/magit/magit/issues/2592.
> If someone would want to have a look some time...that would be nice!

Are you sure you're hitting exactly this same bug?
IOW can you circumvent the bug by adding M-: (point) RET ?


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at 19200 <at> debbugs.gnu.org:


Received: (at 19200) by debbugs.gnu.org; 20 Mar 2016 22:59:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 20 18:59:04 2016
Received: from localhost ([127.0.0.1]:55966 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ahmJM-0000Nt-3f
	for submit <at> debbugs.gnu.org; Sun, 20 Mar 2016 18:59:04 -0400
Received: from mout.web.de ([212.227.15.14]:53410)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1ahmJK-0000NP-3x
 for 19200 <at> debbugs.gnu.org; Sun, 20 Mar 2016 18:59:02 -0400
Received: from drachen.dragon ([94.218.210.27]) by smtp.web.de (mrweb002) with
 ESMTPSA (Nemesis) id 0MMWA2-1aiL4d120U-008G8K;
 Sun, 20 Mar 2016 23:58:53 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#19200: Point adjustemnt moves *into* invisible text
References: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
Date: Sun, 20 Mar 2016 23:58:51 +0100
In-Reply-To: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN> (Stefan Monnier's
 message of "Wed, 26 Nov 2014 17:22:28 -0500")
Message-ID: <87mvpskb84.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K0:4iJRO/HfAN+VgyZr64ri4gXimRYSCuIYL2ljyD6N8hhVFO/1j51
 2POUNe/18L0LwWcYeUTQzBaYGNrYOWP0+dM5EOtXHmrdYyE5LrI3sEn24ndTDMlP/go72lE
 6kdDUroIsnL+gWXYaHGt+ih22CNp2OwQu7gujEOOM6MqlrQlJjy57mvdr+vf76JqE060uWx
 mUtjt5DZACJOhgRZki19Q==
X-UI-Out-Filterresults: notjunk:1;V01:K0:nesCRQcksUk=:55wPlnghwAAtKq/nEumjCs
 YtHIbUQdD3zjLoXrE28XJeroMHuyC/KlUjCoCou+b/IceCI/siIv/qb6SYcaXHVfhDmJxuBvh
 LMeUpK6Fh0ylWoUAkcVg2+ffF5XFAqTowhGiISVG4uiv0N3YIixm7PdwH7OBmE6iFB7Z1EyMV
 sb2KXVmE9VA8eWt9+kUYuyZfa99d0JXiFRVYvRgJky3Klih4OenyFGj7U0z0v8fyP4rePS/GO
 EZtYyfS5XNWa5W4xLozuDd0RgrI7twevntZmAAla818bNqM82CHhx2NH+qvtAwZ9zUbap6q5L
 QKKk8H2pJbFPecbmcR1eqdMR5MMyLtn8NM3nFWtV/X+Wu8u2k31cLvU9H2BltZxHIVTjx+6tt
 dppnQL2RqbFT0vqdzfa3nXDSvxaXny70WWU5R9dey12vAf6H5sSHzTeNj+ojYNDaLDBXrTCRV
 FExUp6lyYvuwprRwbzUqvFK0kL5vj6Ix4X4vcA9+tICExl3lyBq8flY0ry6UD3qXbptAa84SI
 PeDch0UNKqWX6Xolb2tl7RT1kTTh8M9E5Ahxeo9xiciWaYBu4tXvXVcarGsbXxX931v0GqGK9
 DO9fY2Ko8SJn0Kcm91Vv1QNeVgllpVE2Voj9RmjHucQrEPHvYqHxhY60UIU6PPru+g9+8TpSv
 fjar0n5tTkSOZM91vntOmpOfVN5lAWa2P0NnbAILFTHfXaVTcFAdHeqpDNjcXfSXRhSkY3XKO
 fg0ACfgtMTMo0aTTS8AsljeYWqcNZ9hVCtAHQLuV1T5y+QV+VVnMZ68pAU8xG6Ur3f4rFgR1u
 GLMiMpC
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19200
Cc: Jonas Bernoulli <jonas@HIDDEN>, 19200 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Hi,

this bug is tantalizing us in Magit:

  https://github.com/magit/magit/issues/2592.

If someone would want to have a look some time...that would be nice!

Suggestions of how to circumvent the problem until then are welcome
too.


Regards,

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 26 Nov 2014 22:22:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 26 17:22:59 2014
Received: from localhost ([127.0.0.1]:46686 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XtkzD-00070t-Fs
	for submit <at> debbugs.gnu.org; Wed, 26 Nov 2014 17:22:59 -0500
Received: from eggs.gnu.org ([208.118.235.92]:48061)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <monnier@HIDDEN>) id 1XtkzB-00070m-Pq
 for submit <at> debbugs.gnu.org; Wed, 26 Nov 2014 17:22:58 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <monnier@HIDDEN>) id 1Xtkz1-0003XX-Sr
 for submit <at> debbugs.gnu.org; Wed, 26 Nov 2014 17:22:57 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.0 required=5.0 tests=BAYES_40 autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:60406)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <monnier@HIDDEN>) id 1Xtkz1-0003XT-Qs
 for submit <at> debbugs.gnu.org; Wed, 26 Nov 2014 17:22:47 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:49748)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <monnier@HIDDEN>) id 1Xtkyu-0003kz-1h
 for bug-gnu-emacs@HIDDEN; Wed, 26 Nov 2014 17:22:47 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <monnier@HIDDEN>) id 1Xtkym-0003Uu-J6
 for bug-gnu-emacs@HIDDEN; Wed, 26 Nov 2014 17:22:39 -0500
Received: from pruche.dit.umontreal.ca ([132.204.246.22]:35853)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <monnier@HIDDEN>) id 1Xtkym-0003Ul-DR
 for bug-gnu-emacs@HIDDEN; Wed, 26 Nov 2014 17:22:32 -0500
Received: from pastel.home (lechon.iro.umontreal.ca [132.204.27.242])
 by pruche.dit.umontreal.ca (8.14.1/8.14.1) with ESMTP id sAQMMTmB017649;
 Wed, 26 Nov 2014 17:22:29 -0500
Received: by pastel.home (Postfix, from userid 20848)
 id 076DD4820; Wed, 26 Nov 2014 17:22:29 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: Point adjustemnt moves *into* invisible text
Message-ID: <jwvlhmxfvwc.fsf-monnier+emacsbugs@HIDDEN>
X-debbugs-cc: Jonas Bernoulli <jonas@HIDDEN>
Date: Wed, 26 Nov 2014 17:22:28 -0500
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-NAI-Spam-Flag: NO
X-NAI-Spam-Threshold: 5
X-NAI-Spam-Score: 0
X-NAI-Spam-Rules: 1 Rules triggered
	RV5137=0
X-NAI-Spam-Version: 2.3.0.9393 : core <5137> : inlines <1565> : streams
 <1349164> : uri <1836263>
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

1. Yank this in an empty buffer in fundamental-mode and evaluate it.

(progn
  (goto-char (point-min))
  (insert "1\n"
	  (propertize "3\n" 'invisible t)
	  "5\n"
	  "7\n")
	  (backward-char 2))

2. M-< C-n

3. M-: (point) RET

  This should say 3 (where get-pos-property says it's not invisible)
  but returns 5 (where get-pos-property says it is invisible)!

4. M-: (point) RET

  This now returns 3.


-- Stefan




Acknowledgement sent to Stefan Monnier <monnier@HIDDEN>:
New bug report received and forwarded. Copy sent to jonas@HIDDEN, bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to jonas@HIDDEN, bug-gnu-emacs@HIDDEN:
bug#19200; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 22 Mar 2016 19:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.